PLaSK library

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Friends | List of all members
plask::BoundaryConditionsWithMesh< BoundaryT, ValueT > Struct Template Reference

Set of boundary conditions instances for given mesh type and boundary condition description type. More...

`#include <plask/mesh/boundary_conditions.hpp>`

## Public Types
typedef BoundaryT | Boundary
typedef Boundary::MeshType | MeshType
| type of mesh
typedef ValueT | ValueType
| type which describes boundary condition
typedef BoundaryConditionWithMesh< Boundary, ValueType > | Element
| One boundary-condition pair.
typedef elements_container_t::iterator | iterator
typedef elements_container_t::const_iterator | const_iterator

## Public Member Functions
iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
template<typename... ArgsTypes>
| BoundaryConditionsWithMesh (ArgsTypes &&... args)
| Delegate all constructors to underline container (which is std::list<Element>).
Element & | operator[] (std::size_t index)
| Get reference to boundary condition with given `index`.
const Element & | operator[] (std::size_t index) const
| Get const reference to boundary condition with given `index`.
std::size_t | size () const
| Get number of elements.
bool | empty () const
| Check if this is empty.
const_iterator | find (std::size_t mesh_index) const
| Check if any boundary contains a `mesh_index`.
plask::optional< ValueType > | getValue (std::size_t mesh_index) const

## Friends
struct | BoundaryConditions< BoundaryT, ValueType >

## Detailed Description

template<typename BoundaryT, typename ValueT>
struct plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >

Set of boundary conditions instances for given mesh type and boundary condition description type.

Template Parameters

  BoundaryT | type of boundary
  ValueT | type which describe boundary condition Boundaries

Definition at line 95 of file boundary_conditions.hpp.

## Member Typedef Documentation

## ◆ Boundary

template<typename BoundaryT , typename ValueT >

typedef BoundaryT plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::Boundary

Definition at line 97 of file boundary_conditions.hpp.

## ◆ const_iterator

template<typename BoundaryT , typename ValueT >

typedef elements_container_t::const_iterator plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::const_iterator

Definition at line 111 of file boundary_conditions.hpp.

## ◆ Element

template<typename BoundaryT , typename ValueT >

typedef BoundaryConditionWithMesh<Boundary, ValueType> plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::Element

One boundary-condition pair.

Definition at line 102 of file boundary_conditions.hpp.

## ◆ iterator

template<typename BoundaryT , typename ValueT >

typedef elements_container_t::iterator plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::iterator

Definition at line 110 of file boundary_conditions.hpp.

## ◆ MeshType

template<typename BoundaryT , typename ValueT >

typedef Boundary::MeshType plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::MeshType

type of mesh

Definition at line 98 of file boundary_conditions.hpp.

## ◆ ValueType

template<typename BoundaryT , typename ValueT >

typedef ValueT plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::ValueType

type which describes boundary condition

Definition at line 99 of file boundary_conditions.hpp.

## Constructor & Destructor Documentation

## ◆ BoundaryConditionsWithMesh()

template<typename BoundaryT , typename ValueT >
template<typename... ArgsTypes>

plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::BoundaryConditionsWithMesh | ( | ArgsTypes &&... | args | ) |
| inline

Delegate all constructors to underline container (which is std::list<Element>).

Parameters

  args | arguments to delegate

Definition at line 124 of file boundary_conditions.hpp.

## Member Function Documentation

## ◆ begin() [1/2]

template<typename BoundaryT , typename ValueT >

iterator plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::begin | ( |  | ) |
| inline

Definition at line 113 of file boundary_conditions.hpp.

## ◆ begin() [2/2]

template<typename BoundaryT , typename ValueT >

const_iterator plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::begin | ( |  | ) | const
| inline

Definition at line 114 of file boundary_conditions.hpp.

## ◆ empty()

template<typename BoundaryT , typename ValueT >

bool plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::empty | ( |  | ) | const
| inline

Check if this is empty.

It has constant time complexity.

Returns
  `true` only if this container contains no conditions boundaries

Definition at line 166 of file boundary_conditions.hpp.

## ◆ end() [1/2]

template<typename BoundaryT , typename ValueT >

iterator plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::end | ( |  | ) |
| inline

Definition at line 116 of file boundary_conditions.hpp.

## ◆ end() [2/2]

template<typename BoundaryT , typename ValueT >

const_iterator plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::end | ( |  | ) | const
| inline

Definition at line 117 of file boundary_conditions.hpp.

## ◆ find()

template<typename BoundaryT , typename ValueT >

const_iterator plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::find | ( | std::size_t | mesh_index | ) | const
| inline

Check if any boundary contains a `mesh_index`.

Parameters

  mesh_index | index in `mesh`

Returns
  element which boundary contains `mesh_index` or end() if there is no such element

Definition at line 176 of file boundary_conditions.hpp.

## ◆ getValue()

template<typename BoundaryT , typename ValueT >

plask::optional< ValueType > plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::getValue | ( | std::size_t | mesh_index | ) | const
| inline

Definition at line 182 of file boundary_conditions.hpp.

## ◆ operator[]() [1/2]

template<typename BoundaryT , typename ValueT >

Element & plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::operator[] | ( | std::size_t | index | ) |
| inline

Get reference to boundary condition with given `index`.

This method has linear time complexity.

Parameters

  index | index of element

Returns
  reference to boundary condition with given `index`

Exceptions

  OutOfBoundsException | if `index` is not valid

Definition at line 134 of file boundary_conditions.hpp.

## ◆ operator[]() [2/2]

template<typename BoundaryT , typename ValueT >

const Element & plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::operator[] | ( | std::size_t | index | ) | const
| inline

Get const reference to boundary condition with given `index`.

This method has linear time complexity.

Parameters

  index | index of element

Returns
  const reference to boundary condition with given `index`

Exceptions

  OutOfBoundsException | if `index` is not valid

Definition at line 146 of file boundary_conditions.hpp.

## ◆ size()

template<typename BoundaryT , typename ValueT >

std::size_t plask::BoundaryConditionsWithMesh< BoundaryT, ValueT >::size | ( |  | ) | const
| inline

Get number of elements.

This method has linear time complexity.

Returns
  number of elements

Definition at line 156 of file boundary_conditions.hpp.

## Friends And Related Symbol Documentation

## ◆ BoundaryConditions< BoundaryT, ValueType >

template<typename BoundaryT , typename ValueT >

friend struct BoundaryConditions< BoundaryT, ValueType >
| friend

Definition at line 106 of file boundary_conditions.hpp.

The documentation for this struct was generated from the following file:

- plask/mesh/boundary_conditions.hpp